com.io7m.r2.filters

## Class R2FilterBilateralBlurDepthAwareParameters.Builder<SD extends R2RenderTargetDescriptionType,S extends R2RenderTargetUsableType<SD>,DD extends R2RenderTargetDescriptionType,D extends R2RenderTargetUsableType<DD>>

- java.lang.Object
- - com.io7m.r2.filters.R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>

- Enclosing class:
    R2FilterBilateralBlurDepthAwareParameters<SD extends R2RenderTargetDescriptionType,S extends R2RenderTargetUsableType<SD>,DD extends R2RenderTargetDescriptionType,D extends R2RenderTargetUsableType<DD>>

      public static final class R2FilterBilateralBlurDepthAwareParameters.Builder<SD extends R2RenderTargetDescriptionType,S extends R2RenderTargetUsableType<SD>,DD extends R2RenderTargetDescriptionType,D extends R2RenderTargetUsableType<DD>>
      extends Object

  Builds instances of type `R2FilterBilateralBlurDepthAwareParameters`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

  `Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `R2FilterBilateralBlurDepthAwareParameters<SD,S,DD,D>` | `build()` Builds a new `R2FilterBilateralBlurDepthAwareParameters`.
    `R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>` | `from(R2FilterBilateralBlurDepthAwareParametersType<SD,S,DD,D> instance)` Fill a builder with attribute values from the provided `R2FilterBilateralBlurDepthAwareParametersType` instance.
    `R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>` | `setBlurParameters(R2BilateralBlurParameters blurParameters)` Initializes the value for the `blurParameters` attribute.
    `R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>` | `setDepthTexture(R2Texture2DUsableType depthTexture)` Initializes the value for the `depthTexture` attribute.
    `R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>` | `setOutputDescriptionScaler(BiFunction<DD,com.io7m.jareas.core.AreaInclusiveUnsignedLType,DD> outputDescriptionScaler)` Initializes the value for the `outputDescriptionScaler` attribute.
    `R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>` | `setOutputRenderTarget(D outputRenderTarget)` Initializes the value for the `outputRenderTarget` attribute.
    `R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>` | `setOutputTextureSelector(Function<D,R2Texture2DUsableType> outputTextureSelector)` Initializes the value for the `outputTextureSelector` attribute.
    `R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>` | `setRenderTargetPool(R2RenderTargetPoolUsableType<DD,D> renderTargetPool)` Initializes the value for the `renderTargetPool` attribute.
    `R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>` | `setSceneObserverValues(R2MatricesObserverValuesType sceneObserverValues)` Initializes the value for the `sceneObserverValues` attribute.
    `R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>` | `setSourceRenderTarget(S sourceRenderTarget)` Initializes the value for the `sourceRenderTarget` attribute.
    `R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D>` | `setSourceTextureSelector(Function<S,R2Texture2DUsableType> sourceTextureSelector)` Initializes the value for the `sourceTextureSelector` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### from

          public final R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D> from(R2FilterBilateralBlurDepthAwareParametersType<SD,S,DD,D> instance)

      Fill a builder with attribute values from the provided `R2FilterBilateralBlurDepthAwareParametersType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
      Parameters:
        `instance` - The instance from which to copy values
      Returns:
        `this` builder for use in a chained invocation

    - #### setSourceRenderTarget

          public final R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D> setSourceRenderTarget(S sourceRenderTarget)

      Initializes the value for the `sourceRenderTarget` attribute.
      Parameters:
        `sourceRenderTarget` - The value for sourceRenderTarget
      Returns:
        `this` builder for use in a chained invocation

    - #### setSourceTextureSelector

          public final R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D> setSourceTextureSelector(Function<S,R2Texture2DUsableType> sourceTextureSelector)

      Initializes the value for the `sourceTextureSelector` attribute.
      Parameters:
        `sourceTextureSelector` - The value for sourceTextureSelector
      Returns:
        `this` builder for use in a chained invocation

    - #### setOutputRenderTarget

          public final R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D> setOutputRenderTarget(D outputRenderTarget)

      Initializes the value for the `outputRenderTarget` attribute.
      Parameters:
        `outputRenderTarget` - The value for outputRenderTarget
      Returns:
        `this` builder for use in a chained invocation

    - #### setOutputTextureSelector

          public final R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D> setOutputTextureSelector(Function<D,R2Texture2DUsableType> outputTextureSelector)

      Initializes the value for the `outputTextureSelector` attribute.
      Parameters:
        `outputTextureSelector` - The value for outputTextureSelector
      Returns:
        `this` builder for use in a chained invocation

    - #### setRenderTargetPool

          public final R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D> setRenderTargetPool(R2RenderTargetPoolUsableType<DD,D> renderTargetPool)

      Initializes the value for the `renderTargetPool` attribute.
      Parameters:
        `renderTargetPool` - The value for renderTargetPool
      Returns:
        `this` builder for use in a chained invocation

    - #### setOutputDescriptionScaler

          public final R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D> setOutputDescriptionScaler(BiFunction<DD,com.io7m.jareas.core.AreaInclusiveUnsignedLType,DD> outputDescriptionScaler)

      Initializes the value for the `outputDescriptionScaler` attribute.
      Parameters:
        `outputDescriptionScaler` - The value for outputDescriptionScaler
      Returns:
        `this` builder for use in a chained invocation

    - #### setSceneObserverValues

          public final R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D> setSceneObserverValues(R2MatricesObserverValuesType sceneObserverValues)

      Initializes the value for the `sceneObserverValues` attribute.
      Parameters:
        `sceneObserverValues` - The value for sceneObserverValues
      Returns:
        `this` builder for use in a chained invocation

    - #### setDepthTexture

          public final R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D> setDepthTexture(R2Texture2DUsableType depthTexture)

      Initializes the value for the `depthTexture` attribute.
      Parameters:
        `depthTexture` - The value for depthTexture
      Returns:
        `this` builder for use in a chained invocation

    - #### setBlurParameters

          public final R2FilterBilateralBlurDepthAwareParameters.Builder<SD,S,DD,D> setBlurParameters(R2BilateralBlurParameters blurParameters)

      Initializes the value for the `blurParameters` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `blurParameters`.

      Parameters:
        `blurParameters` - The value for blurParameters
      Returns:
        `this` builder for use in a chained invocation

    - #### build

          public R2FilterBilateralBlurDepthAwareParameters<SD,S,DD,D> build()

      Builds a new `R2FilterBilateralBlurDepthAwareParameters`.
      Returns:
        An immutable instance of R2FilterBilateralBlurDepthAwareParameters
      Throws:
        `IllegalStateException` - if any required attributes are missing

Copyright © 2017 <code@io7m.com> http://io7m.com